﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using OpenTK;
//using OpenTK.Graphics;
using OpenTK.Graphics.OpenGL;
using OpenTK.Audio;
using OpenTK.Audio.OpenAL;
using OpenTK.Input;


namespace WindowsFormsApplication2
{
    public partial class Form1 : Form
    {
        float AngleX = 0;
        float AngleY = 0;
        float AngleZ = 0;

        const float AngleDl = 5;

        double n = 1;
        double z = 1;

        public Form1()
        {
            InitializeComponent();
        }

        private void glControl1_Resize(object sender, EventArgs e)
        {
            GL.Viewport(0, 0, glControl1.Width, glControl1.Height);
            GL.MatrixMode(MatrixMode.Projection);
            GL.LoadIdentity();
            GL.Ortho(-6, 6, -6, 6, -6, 6);
            GL.MatrixMode(MatrixMode.Modelview);
            glControl1.Invalidate();
        }

        private void glControl1_Paint(object sender, PaintEventArgs e)
        {
            // очистка буферов цвета и глубины
            GL.Clear(ClearBufferMask.ColorBufferBit | ClearBufferMask.DepthBufferBit);

            // поворот изображения
            GL.LoadIdentity();
            GL.Rotate(AngleX, 1.0, 0.0, 0.0);
            GL.Rotate(AngleY, 0.0, 1.0, 0.0);
            GL.Rotate(AngleZ, 0.0, 0.0, 1.0);

             // оси координат
             GL.Begin(BeginMode.Lines);
               // ось x
               GL.Color3(1f, 1, 1); GL.Vertex2(-6, 0);
               GL.Color3(0f, 0, 1); GL.Vertex2(6, 0);
               // ось y
               GL.Color3(1f, 1, 1); GL.Vertex2(0, -6);
               GL.Color3(0f, 1, 0); GL.Vertex2(0, 6);
               // ось z
               GL.Color3(1f, 1, 1); GL.Vertex3(0, 0, -6);
               GL.Color3(1f, 0, 0); GL.Vertex3(0, 0, 6);
             GL.End();

             // функция Sin(x)
             GL.Color3(1f, 0, 0);
             GL.Begin(BeginMode.LineStrip);
               for (int i = -50; i <= 50; ++i)
               {
                 double x = i * 0.1;
                 GL.Vertex2(x, Math.Sin(x*n)*z);
               }
             GL.End();

            GL.Flush();
            GL.Finish();

            glControl1.SwapBuffers();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            GL.ClearColor(0.5f, 0.5f, 0.75f, 1.0f); // цвет фона
        }


        private void glControl1_PreviewKeyDown(object sender, PreviewKeyDownEventArgs e)
        {
            switch (e.KeyCode)
            {
                case Keys.Insert: AngleX += AngleDl; break;
                case Keys.Delete: AngleX -= AngleDl; break;
                case Keys.Home: AngleY += AngleDl; break;
                case Keys.End: AngleY -= AngleDl; break;
                case Keys.Prior: AngleZ += AngleDl; break;
                case Keys.Next: AngleZ -= AngleDl; break;

                case Keys.Up: z += 0.1; break;
                case Keys.Down: z -= 0.1; break;
                case Keys.Left: n -= 0.1; break;
                case Keys.Right: n += 0.1; break;
            }
            glControl1.Invalidate();
            Text =
                String.Format("График функции y = {0}*Sin(x*{1})", z, n);
        }
    }
}
