unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  OpenGL, ToolsOGL;

type
  TfrmMain = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormResize(Sender: TObject);
  end;
const
  AngleDl=5; //     
var
  frmMain: TfrmMain;
  DC : HDC;
  hrc: HGLRC;
  AngleX, AngleY, AngleZ: integer;

  n: double =1;
  z: double =1;
implementation

{$R *.DFM}

//  
procedure TfrmMain.FormPaint(Sender: TObject);
var
  i: integer;
  x: double;
begin
 glClear (GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);      //   
 glLoadIdentity;

 //      
 glRotatef(AngleX, 1.0, 0.0, 0.0);
 glRotatef(AngleY, 0.0, 1.0, 0.0);
 glRotatef(AngleZ, 0.0, 0.0, 1.0);

 //  
 glBegin (GL_LINES);
   //  x
   glColor3f(1, 1, 1); glVertex2f (-6, 0);
   glColor3f(0, 0, 1); glVertex2f (6, 0);
   //  y
   glColor3f(1, 1, 1); glVertex2f (0, -6);
   glColor3f(0, 1, 0); glVertex2f (0, 6);
   //  z
   glColor3f(1, 1, 1); glVertex3f (0, 0, -6);
   glColor3f(1, 0, 0); glVertex3f (0, 0, 6);
 glEnd;

 //  Sin(x)
 glColor3f(1, 0, 0);
 glBegin (GL_LINE_STRIP);
   for i:=-50 to 50 do
   begin
     x := i*0.1;
     glVertex2f (x, Sin(x*n)*z);
   end;
 glEnd;

 glFlush;
 glFinish;

 SwapBuffers(DC);
end;

//  
procedure TfrmMain.FormCreate(Sender: TObject);
var
 pfd : TPixelFormatDescriptor;
 nPixelFormat : Integer;
begin

 //       -
 n := 1;
 z := 1;

 DC := GetDC (Handle);

 // 
 FillChar (pfd, SizeOf (pfd), 0);
 pfd.dwFlags  := PFD_DRAW_TO_WINDOW or PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER;
 nPixelFormat := ChoosePixelFormat (dc, @pfd);
 SetPixelFormat (dc, nPixelFormat, @pfd);

 hrc := wglCreateContext(DC);
 wglMakeCurrent(DC, hrc);

 //   :
 AngleX:=0;
 AngleY:=0;
 AngleZ:=0;

 glClearColor (0.5, 0.5, 0.75, 1.0); //  
 glEnable(GL_DEPTH_TEST);
end;

//   
procedure TfrmMain.FormDestroy(Sender: TObject);
begin
 wglMakeCurrent(0, 0);
 wglDeleteContext(hrc);
 ReleaseDC (Handle, DC);
 DeleteDC(DC);
end;

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 If Key = VK_ESCAPE then Close;
 case Key of
  VK_INSERT: inc(AngleX, AngleDl);
  VK_DELETE: dec(AngleX, AngleDl);

  VK_HOME:   inc(AngleY, AngleDl);
  VK_END:    dec(AngleY, AngleDl);

  VK_PRIOR:  inc(AngleZ, AngleDl);
  VK_NEXT:   dec(AngleZ, AngleDl);

  //      -
  VK_UP:     z := z + 0.1;
  VK_DOWN:   z := z - 0.1;
  VK_LEFT:   n := n - 0.1;
  VK_RIGHT:  n := n + 0.1;
 end;
 InvalidateRect(Handle, nil, False);
 Caption := '  y = '+ FloatToStr(z) +' *Sin(x*'+FloatToStr(n)+')';
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
 glViewport(0, 0, ClientWidth, ClientHeight);
 glMatrixMode(GL_PROJECTION);
 glLoadIdentity;
 glOrtho(-6, 6, -6, 6, -6, 6);
 glMatrixMode(GL_MODELVIEW);
 InvalidateRect(Handle, nil, False);
end;

end.

